/* This is a simple demo of a Rexx (modelled after the JavaScript) script that
   uses the Java URL class to download some content from some URL. rgf, 2003-02-17, 2003-04-18 */


if rxFuncQuery("BSF") then  /* no bsf4rexx support available yet, hence load Java */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* load all BSF-functions                    */
   call BsfLoadJava     /* load the JVM and set up BSF4Rexx-support  */
end

if      BsfInvokedBy()=1 then say "This Rexx program was invoked by Java!"
else if BsfInvokedBy()=2 then say "This Rexx program was invoked by Rexx, JVM loaded by Rexx!"
else                          say "No JVM present, we got troubles ..."


URL_ADDR = "http://www.RexxLA.org/";
say "connecting to:" URL_ADDR
url=bsf("registerBean", "", "java.net.URL", "String", URL_ADDR) /* create a java.net.URL instance */
content = bsf('invoke', url, "getContent")   /* get the content object, a <java.io.FilterInputStream> */
say "Downloading .. "

size=8*1024    /* use chunks of maximum 8 KB */
      /* "Array.class" and "byte.class" are pre-loaded on the Java side, hence usable already */
byteArray=bsf("invoke", "Array.class", "newInstance", "object", "byte.class", "int", size)

len=""
do until len=-1
   len=bsf("invoke", content, "read", "obj", byteArray, "int", 0, "int", size)   /* read the content into the byte array */
   if len>0 then
   do
      stringObject=bsf("registerBean", , "java.lang.String", "obj", byteArray)   /* create a Java String from the byte array */
      call charout , left( bsf("invoke", stringObject, "toString"), len)  /* get the string itself, use the read bytes as its length */
      call bsf "unregisterBean", stringObject      /* remove the String Object from the Java repository */
   end
end

